## bombono-dvd-dmo 1.2.4

=== SConstruct ===
#!/usr/bin/env python
import string
import os
import sys

scripts_path = 'tools/scripts'

sys.path.append(scripts_path)
import BuildVars as BV

#
# Atom's project main SConstruct file
#
# (inspired by Blender's SConstruct file,
#  http://www.blender.org/)
#

BV.Args = ARGUMENTS
BV.Targets = COMMAND_LINE_TARGETS

############################################
# Dependency libraries & Settings

# via pkg-config
RequiredLibs = ['glibmm-2.4', 'libxml++-2.6', 'gtkmm-2.4']
FFmpegLibs   = ['libavformat', 'libavcodec', 'libswscale', 'libavutil']
RequiredLibs += FFmpegLibs

# :TODO: convert to config.opts option
ConfigGPL = False

# define path to libs
def SetLibraries(config, user_options_dict):
    for lib in RequiredLibs:
        BV.SetLibInfo(config, user_options_dict, lib)

# 
def AddLibOptions(user_options):
    # we make arg's tuple from list
    args = tuple([ (BV.MakeDictName(lib),) for lib in RequiredLibs ])
    user_options.AddVariables(*args)


# legacy stuff (support for GM is hard => trash)
# to turn on:
# 1. False -> True
# 2. uncomment in src/SConscript
BuildMcomposite = False
if BuildMcomposite:
    RequiredLibs.extend(['mjpegtools', 'GraphicsMagick++'])

# global -pthread
IsThreadedBuild = False
ThreadOpt = ['-pthread']
            
############################################
# Compilers

common_warn_flags = []
cxx_warn_flags    = []
debug_flags   = ['-g', '-O0']
release_flags = ['-O2']
defines       = []

def CalcCommonFlags():
    if BV.IsReenter(CalcCommonFlags):
        return

    global common_warn_flags, cxx_warn_flags, debug_flags, defines
    if BV.IsGccCompiler():
        # GCC
        common_warn_flags = ['-ansi']
        # -std=c++11 is required by sigc++, shit
        # and auto_ptr is deprecated, so
        common_warn_flags.extend(['-std=c++11', "-Wno-deprecated-declarations"])

        # -Wno-reorder - not to warn if not accurate order in ctor (let compiler do!)
        # :TODO: why 
        #   CXXCOM = $CXX -o $TARGET -c $CXXFLAGS $CCFLAGS ...
        # but not
        #   CXXCOM = $CXX -o $TARGET -c $CCFLAGS $CXXFLAGS ...
        cxx_warn_flags = ['-Wall', '-W', '-Wno-reorder'] # -W == -Wextra
        # Oh, GCC! Just give me the speed. If you don't stop getting slower, I'll go to Clang.
        debug_flags += ['-pipe']
    elif BV.IsClangCompiler():
        common_warn_flags = ['-ansi']
        cxx_warn_flags    = [
            '-Wall', '-Wno-reorder', 
            '-Wno-unused-variable'   # many Boost code throws it like "boost::lambda::_1"
        ]
    elif BV.Cc == 'como' or BV.Cxx == 'como':
        # Comeau compiler
        #
        # Currently used as compile-link check only to conform "clean C++" better.
        # See extended remarks about settings used here
        #

        # don't mix compilers
        BV.Cc  = 'como'
        BV.Cxx = 'como'

        common_warn_flags = \
        [
         # accept defines like #define g_error(...) __VA_ARGS__   
         '--variadic_macros', 
         # 1   do not warn when overloaded virtual function is partially overridden
         # 2,3 type qualifiers are meaningless
         # 4   delete of pointer to incomplete class
         '--diag_suppress=611,21,815,414',
        ]
        cxx_warn_flags = []
        # policy: no XOPEN things meanwhile.
        defines = [ 
                    ('_POSIX_C_SOURCE','200112L'),  # fdopen(), fileno(), ...
                    'BOOST_NO_INT64_T',             # Glibc' int64_t trap for non-gcc compilers
                    '_ISOC99_SOURCE'                # C99 extentions: snprintf()
                  ]

#
# Users CPPFLAGS support
# Because SCons cannot handle -U option (~ #undef) it is done via
# additional variable named POST_CPPFLAGS
#
UserCppFlags = ''

def AdjustConfigOptions(env):
    CalcCommonFlags()

    if BV.IsDebugCfg():
        cflags = debug_flags
    else:
        cflags = release_flags

    ldflags = []
    #if BV.BuildProfile:
    #    cflags += profile_flags
    #    ldflags += profile_flags
    
    env.Replace(CC = BV.Cc)
    env.Replace(CXX = BV.Cxx)
    env.Prepend(CCFLAGS = cflags)
    env.Prepend(LINKFLAGS = ldflags)
    env.Prepend(CPPDEFINES = defines)
    
    # to be able to override previous options (not just to add)
    env.Append(CCFLAGS = BV.CFlags.split())
    env.Append(CXXFLAGS = BV.CxxFlags.split())
    env.Append(LINKFLAGS = BV.LdFlags.split())
    env.Append(POST_CPPFLAGS = UserCppFlags.split())
        
    # :TODO: set them when need
    #env.Replace (PATH = user_options_dict['PATH'])
    #env.Replace (AR = user_options_dict['AR'])

    # Large File Support
    if not BV.IsReenter(AdjustConfigOptions):
        if BV.IsSConsLE_0_96(env):
            # :TRICKY: nobody but me uses so old scons, so I do it straight
            dict = { 'CPPDEFINES': ['_LARGEFILE_SOURCE', ('_FILE_OFFSET_BITS', '64')] }
        else:
            dict = BV.ParseFlagsForCommand('getconf LFS_CFLAGS', 1)
            dict.update(BV.ParseFlagsForCommand('getconf LFS_LDFLAGS'))
            dict.update(BV.ParseFlagsForCommand('getconf LFS_LIBS'))
        AdjustConfigOptions.lfs = dict
    env.Append(**AdjustConfigOptions.lfs)

    # Multithreading, global
    if IsThreadedBuild:
        env.Append(CCFLAGS = ThreadOpt, LINKFLAGS = ThreadOpt)

############################################
# Defaults

BV.CfgFile  = BV.Args.get('CFG_FILE','config.opts')

def_env = Environment(ENV = os.environ)
def_env_dict  = def_env.Dictionary()

user_options_dict = {} 

Variables = BV.Variables
EnumVariable = BV.EnumVariable
BoolVariable = BV.BoolVariable

def ParseVariables(user_options):
    user_options.AddVariables (
            (EnumVariable('BUILD_CFG',
                        'Select release or debug build.', 
                        'release', allowed_values = ('release', 'debug'))),
    		('BUILD_DIR', 'Target directory for intermediate files.',
    					'build'),
            (BoolVariable('BUILD_BRIEF',
                        'Set to 1 if you want brief compiling/linking output.',
                        'false')),
            (EnumVariable('BUILD_QUICK',
                        "Set to 'true' if you want to reduce building time using: \n"
                        "\t1) PCH - precompiled headers \n"
                        "\t2) some SCons perfomance tuning.\n"
                        "\t'auto' implies true for debug build and false for release one.",
                        'auto', allowed_values = ('auto', 'false', 'true'))),
            ('PREFIX',  'Change the default install directory.', '/usr/local'),
            ('DESTDIR', 'Set the intermediate install directory.', ''),
            ('CC', 'C compiler.'),
            ('CXX', 'C++ compiler.'),
            ('CPPFLAGS','Extra CPP flags.', ''),
            ('CFLAGS',  'Extra C Compiler flags (for C++ too).', ''),
            ('CXXFLAGS','Extra C++ Compiler flags.', ''),
            ('LDFLAGS', 'Extra Linker flags.', ''),
            (BoolVariable('TEST',
                        'Set to 1 if you want to build and run tests.',
                        'false')),
            (BoolVariable('USE_EXT_BOOST',
                        'Leave this setting 0 to use embedded Boost library version (not recommended).',
                        'true')),
            ('BOOST_INCLUDE', 'Set to include path for external(not embedded) version of the Boost library.', ''),
            ('BOOST_LIBPATH', 'Set to library dir path for external(not embedded) version of the Boost library.', ''),
            ('DVDREAD_INCLUDE', 'Set to include path for libdvdread header files.', ''),
            ('DVDREAD_LIBPATH', 'Set to library path where the libdvdread is located.', ''),
            # Undocumented
            (BoolVariable('TEST_BUILD',
                        'Set to 1 if you want to build with tests (all).',
                        'false')),
            (BoolVariable('USE_EXT_ASL',
                        'Leave this setting 0 to use embedded ASL library version (recommended).',
                        'false')),
            )
    # we need to add 'lib dict vars' user_options to load in user_options_env
    AddLibOptions(user_options)

    # Configuration
    def add_calc_variables(*lst):
        lst = ((name,) for name in lst)
        user_options.AddVariables( *lst )
    add_calc_variables('IS_GCC', 'IS_CLANG', 'CONFIGURATION')

    # make help (scons -h)
    user_options_env = Environment(ENV = os.environ, options = user_options)
    Help(user_options.GenerateHelpText(user_options_env))
    # fill in user_env_dict
    global user_options_dict
    user_options_dict = user_options_env.Dictionary()
    # must be later than assigning
    BV.InitUOD(user_options_dict)
    Export('user_options_dict')
    user_options_dict['AdjustConfigOptions'] = AdjustConfigOptions

    # fill in BuildVars
    BV.BuildCfg = user_options_dict['BUILD_CFG']
    BV.BuildDir = user_options_dict['BUILD_DIR']
    BV.BuildBrief = user_options_dict['BUILD_BRIEF']

    BV.Cc  = user_options_dict['CC']
    BV.Cxx = user_options_dict['CXX']
    global UserCppFlags
    UserCppFlags  = user_options_dict['CPPFLAGS']
    BV.CFlags = user_options_dict['CFLAGS']
    BV.CxxFlags = user_options_dict['CXXFLAGS']
    BV.LdFlags  = user_options_dict['LDFLAGS']
    BV.RunTests = user_options_dict['TEST']
    BV.BuildTests = user_options_dict['TEST_BUILD']

    # make build dir if not exist;
    # need to make manually for .sconsign
    if os.path.isdir(BV.BuildDir) == 0:
    	os.makedirs(BV.BuildDir)
    #SourceSignatures('timestamp')
    SConsignFile(BV.BuildDir+os.sep+'.sconsign')
    # conf dir
    user_options_dict['ConfigDir'] = BV.BuildDir+ '/' + BV.GetSrcDirPath() +'/cfg'
    user_options_dict['DVDREAD_DICT'] = { 'CPPPATH' : [user_options_dict['DVDREAD_INCLUDE']],
                                          'LIBPATH' : [user_options_dict['DVDREAD_LIBPATH']] }

############################################
# Config

if os.path.exists( BV.CfgFile ):
    print "Using config file: " + BV.CfgFile

    user_options = Variables(BV.CfgFile, BV.Args)
    ParseVariables(user_options)

else:
    print "Creating new config file: " + BV.CfgFile

    user_options = Variables(None, BV.Args)
    ParseVariables(user_options)
    try:
        def write_name_value(name, val):
            config.write('%s = %r\n' % (name, val))
        def write_dict_value(name):
            write_name_value(name, user_options_dict[name])

        # save to file
        config = open(BV.CfgFile, 'w')
    
        config.write("# Options for building Atom project\n")
        config.write('BUILD_CFG = %r\n' % (BV.BuildCfg))
        config.write('BUILD_DIR = %r\n' % (BV.BuildDir))
        config.write('BUILD_BRIEF = %r\n' % (BV.BuildBrief))
        write_dict_value('BUILD_QUICK')
        config.write('TEST = %r\n' % (BV.RunTests))
        write_dict_value('PREFIX')
        write_dict_value('DESTDIR')
    
        config.write('\n# Compiler information\n')
        config.write('CC = %r\n' % (BV.Cc))
        config.write('CXX = %r\n' % (BV.Cxx))
        write_name_value('CPPFLAGS', UserCppFlags)
        config.write('CFLAGS = %r\n' % (BV.CFlags))
        config.write('CXXFLAGS = %r\n' % (BV.CxxFlags))
        config.write('LDFLAGS = %r\n' % (BV.LdFlags))

        config.write('\n# Boost library\n')
        write_dict_value('USE_EXT_BOOST')
        write_dict_value('BOOST_INCLUDE')
        write_dict_value('BOOST_LIBPATH')

        config.write('\n# libdvdread library\n')
        write_dict_value('DVDREAD_INCLUDE')
        write_dict_value('DVDREAD_LIBPATH')

        config.write('\n### Calculated data ###\n')
        SConscript('Autoconfig')

        config.write('\n')
        write_dict_value('IS_GCC')
        write_dict_value('IS_CLANG')

        config.write('\n# Configuration\n')
        write_dict_value('CONFIGURATION')

        SetLibraries(config, user_options_dict)

        config.write('\n# Undocumented\n')
        # this one has only one purpose I can say: just build all

=== debian/changelog ===
bombono-dvd-dmo (1:1.2.4-dmo7+deb11u2) stable; urgency=medium

  * Really install SConsTwin.py

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 21 Apr 2022 00:49:08 +0200

bombono-dvd-dmo (1:1.2.4-dmo7+deb11u1) stable; urgency=medium

  * Fix installation of SConsTwin.py
  * Changes shebang for python scripts to /usr/bin/python3

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 11 Apr 2022 10:57:27 +0200

bombono-dvd-dmo (1:1.2.4-dmo7) unstable; urgency=medium

  * Build with boost 1.74
  * Should Depends on sensible-utils

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 24 Dec 2020 09:33:10 +0100

bombono-dvd-dmo (1:1.2.4-dmo6) unstable; urgency=medium

  * Build with boost 1.71

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 02 Jun 2020 13:43:31 +0200

bombono-dvd-dmo (1:1.2.4-dmo5) unstable; urgency=medium

  * Build with libdvdread8

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 08 Apr 2020 08:06:51 +0200

bombono-dvd-dmo (1:1.2.4-dmo4) unstable; urgency=medium

  * Build with libdvdread7

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 26 Nov 2019 01:15:20 +0100

bombono-dvd-dmo (1:1.2.4-dmo3) unstable; urgency=medium

  * Rebuild against boost 1.67

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 13 Nov 2018 23:55:09 +0100

bombono-dvd-dmo (1:1.2.4-dmo2) unstable; urgency=medium

  * Rebuild against ffmpeg 4.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 22 Apr 2018 16:59:20 +0200

bombono-dvd-dmo (1:1.2.4-dmo1) unstable; urgency=medium

  * New upstream release.
  * Replaces obsolete ttf-freefont dependency by fonts-freefont-ttf (Thanks
    to Julian Gilbey for the bug report).
  * Fix build with a patch from Archlinux (11_operator_ambiguity).

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 19 Nov 2017 10:42:34 +0100

bombono-dvd-dmo (1:1.2.2-dmo13) unstable; urgency=medium

  * Rebuild against boost 1.62

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 02 Nov 2016 18:04:19 +0100

bombono-dvd-dmo (1:1.2.2-dmo12) unstable; urgency=medium

  * Rebuild against boost 1.61

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 08 Aug 2016 07:43:19 +0200

bombono-dvd-dmo (1:1.2.2-dmo11) unstable; urgency=medium

  * Rebuild against ffmpeg 3.0 libraries.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 21 Feb 2016 07:31:50 +0100

bombono-dvd-dmo (1:1.2.2-dmo10) unstable; urgency=medium

  * Fix FTBFS

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 14 Feb 2016 10:49:01 +0100

bombono-dvd-dmo (1:1.2.2-dmo9) unstable; urgency=medium

  * Rebuild against libatkmm-1.6-1v5

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 20 Aug 2015 07:24:17 +0200

bombono-dvd-dmo (1:1.2.2-dmo8) unstable; urgency=medium

  * Rebuild against libglibmm-2.4-1v5

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 08 Aug 2015 19:47:40 +0200

bombono-dvd-dmo (1:1.2.2-dmo7) unstable; urgency=medium

  * Rebuild against ffmpeg 2.4

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 16 Sep 2014 09:35:25 +0200

bombono-dvd-dmo (1:1.2.2-dmo6) unstable; urgency=medium

  * Rebuild against boost 1.55

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 20 May 2014 11:28:59 +0200

bombono-dvd-dmo (1:1.2.2-dmo5) unstable; urgency=high

  * Rebuild. Packages in the repository for unstable/testing are broken
    (Thanks to Umberto Zappi for the bug report).

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 16 Mar 2014 18:53:33 +0100

bombono-dvd-dmo (1:1.2.2-dmo4) unstable; urgency=low

  * Rebuild against ffmpeg 2.1 libraries.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 25 Nov 2013 11:29:07 +0100

bombono-dvd-dmo (1:1.2.2-dmo3) unstable; urgency=low

  * Don't build the package twice.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Aug 2013 12:57:52 +0200

bombono-dvd-dmo (1:1.2.2-dmo2) unstable; urgency=low

  * Rebuild against libboost 1.54

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 18 Aug 2013 12:19:26 +0200

bombono-dvd-dmo (1:1.2.2-dmo1) unstable; urgency=low

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 08 Mar 2013 08:50:05 +0100

bombono-dvd-dmo (1:1.2.1-dmo2) unstable; urgency=low

  * Add -dmo to source name.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 09 Oct 2012 13:01:08 +0200

bombono-dvd (1.2.1-dmo1) unstable; urgency=low

  * Rebuild against libavcodec54 and libboost 1.49

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 15 Jun 2012 08:32:19 +0200

bombono-dvd (1.2.1-0.2) unstable; urgency=low

  * Really fix manpages issue.

 -- Christian Marillat <marillat@debian.org>  Wed, 08 Feb 2012 19:44:30 +0100

bombono-dvd (1.2.1-0.1) unstable; urgency=low

  * Add a Replaces bombono-dvd for bombono-dvd-data.

 -- Christian Marillat <marillat@debian.org>  Wed, 08 Feb 2012 19:39:13 +0100

bombono-dvd (1.2.1-0.0) unstable; urgency=low

  * New upstream release.

 -- Christian Marillat <marillat@debian.org>  Wed, 08 Feb 2012 15:15:11 +0100

bombono-dvd (1.2.0-0.1) unstable; urgency=low

  * Rebuild against ffmpeg.

 -- Christian Marillat <marillat@debian.org>  Mon, 23 Jan 2012 10:11:00 +0100

bombono-dvd (1.2.0-0.0) unstable; urgency=low

  * New upstream release.

 -- Christian Marillat <marillat@debian.org>  Mon, 14 Nov 2011 17:26:03 +0100

bombono-dvd (1.0.2-0.1) unstable; urgency=low

  * Dedicated to my friend Zef.
  * Really replace mkisofs by genisoimage everywhere.
  * New patch 03_ffmpeg-0.8 to fix build with ffmpeg 0.8

 -- Christian Marillat <marillat@debian.org>  Sun, 17 Jul 2011 11:04:49 +0200

bombono-dvd (1.0.2-0.0) unstable; urgency=low

  * New upstream release.

 -- Christian Marillat <marillat@debian.org>  Mon, 18 Apr 2011 12:22:59 +0200

bombono-dvd (1.0.1-0.2) unstable; urgency=low

  * debian/control Replace libgraphicsmagick++1-dev by
    libgraphicsmagick++-dev in Build-Depends.



=== debian/control ===
Source: bombono-dvd-dmo
Section: graphics
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: http://www.bombono.com
Rules-Requires-Root: no
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), scons, libdvdread-dev, libswscale-dev,
 libgtkmm-2.4-dev (>= 1:2.24.4-2),, libxml++2.6-dev, libmjpegtools-dev, quilt,
 libmagick++-6-headers, libavcodec-dev, libboost-regex-dev (>= 1.71~),
 libboost-filesystem-dev, libavformat-dev (>= 10:4.0~)

Package: bombono-dvd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, genisoimage, dvdauthor, mjpegtools,
 dvd+rw-tools, twolame, bombono-dvd-data (>= ${source:Version}), scons, fonts-freefont-ttf, ffmpeg, sensible-utils
Suggests: totem
Description: DVD authoring program with nice and clean GUI
 Bombono DVD is easy to use program for making DVD-Video.
 The main features of Bombono DVD are:
  * excellent MPEG viewer: Timeline and Monitor
  * real WYSIWYG Menu Editor with live thumbnails
  * comfortable Drag-N-Drop support
  * you can author to folder, make ISO-image or burn directly to DVD
  * reauthoring: you can import video from DVD discs.

Package: bombono-dvd-data
Architecture: all
Enhances: bombono-dvd
Depends: ${misc:Depends}, python3:any
Replaces: bombono-dvd (<= 1.2.1-0.1)
Description: Common data for bombono-dvd
 This package contains architecture-independent data files needed by
 bombono-dvd.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(findstring parallel=,$(DEB_BUILD_OPTIONS)))
	NCPUS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
	ifeq ($(NCPUS),-1)
		NCPUS:=1
	endif
	ifeq ($(NCPUS),0)
		NCPUS:=1
	endif
endif

export DEB_CXXFLAGS_MAINT_APPEND = -std=gnu++11
export DEB_CFLAGS_MAINT_APPEND = -D_FORTIFY_SOURCE=2
export DEB_CPPFLAGS_MAINT_APPEND = -DBOOST_SYSTEM_NO_DEPRECATED -DBOOST_FILESYSTEM_VERSION=3 -DBOOST_FILESYSTEM_NO_DEPRECATED -D_FORTIFY_SOURCE=2

%:
	dh $@ --with quilt

override_dh_auto_install:
	scons USE_EXT_BOOST=true PREFIX=/usr BOOST_LIBPATH=/usr/include/boost \
	DESTDIR=$(CURDIR)/debian/tmp CPPFLAGS="$(CPPFLAGS)" \
	LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" install \
	CXXFLAGS="$(CXXFLAGS)" -j $(NCPUS)

	chmod -x debian/tmp/usr/share/bombono/resources/icons/*.svg

override_dh_clean:
	dh_clean tools/scripts/*.pyc config.opts
	rm -rf build
	rm -rf tools/scripts/__pycache__/

=== debian/watch ===
version=4

opts="uversionmangle=s/_signed_for_dubrovskiy//" \
https://github.com/muravjov/bombono-dvd/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
